import java.awt.*;
import java.applet.*;
import java.io.*;
import java.sql.*;
import java.util.Date;

/*
	<applet code="FrontPage" width=375 height=200>
	 Sorry, your browser does not support Java. Please contact
	 us at: assoc@math.iitb.ernet.in for online registration.
	</applet>
*/

public class FrontPage extends Applet
{
	boolean helped = false;
	myHelpFrame helpFrame;
	myDialogFrame inputFrame;

	public void init()
	{
		add ( new Label ( "Online Registration for the MATHEMATICS OLYMPIAD", Label.CENTER ) );

		Button help = new Button ( "Help" );
		Button register = new Button ( "Register" );

		add ( help );
		add ( register );
	}

	public void stop() { if ( helped ) helpFrame.hide(); }

	public boolean action ( Event evtObj, Object arg )
	{
		if ( evtObj.target instanceof Button )
		{
			if ( arg.equals ( "Help" ) )
			{
				helped = true;
				helpFrame = new myHelpFrame ( "Online Registration Help" );
				helpFrame.show();
				helpFrame.resize ( 400, 300 );
			}
			else
			{
				inputFrame = new myDialogFrame ( "Register Online" );
				inputFrame.show();
			}
			return true;
		}
		return false;
	}
}

class myHelpFrame extends Frame
{
	myHelpFrame ( String title ) { super ( title ); }

	public boolean handleEvent ( Event evtObj )
	{
		if ( evtObj.id == Event.WINDOW_DESTROY )
		{
			hide();
			return true;
		}
		return super.handleEvent ( evtObj );
	}

	public void paint ( Graphics g )
	{
		g.drawString ( "Help message goes here", 110, 120 );
	}
}

class myDialog extends Dialog
{
	//declare jdbc variables
	// The driver to load
	static final String driver = "oracle.jdbc.driver.OracleDriver";

	// The connect string 
	static final String connect_string = 
                  "jdbc:oracle:thin:satyam/satyam@everest:1521:GEN";

	// The connection to the database
	Connection conn;

	// End of jdbc variables. Regular code continues...


	TextField name, address;
	CheckboxGroup category;
	Checkbox junior, senior, iitans, non_st;
	CheckboxGroup sex;
	Checkbox male, female;
	Scrollbar dob_day, dob_month, dob_year;
	java.sql.Date dob;
	Label dob_label;
	Label roll;
	int RollNo;

	List inst_List;
	Button accept, cancel;

	String institute = "";

	myDialog ( Frame parent, String title )
	{
		super ( parent, title, true );

		name = new TextField ( "", 40 );
		address = new TextField ( "", 30 );
		
		category = new CheckboxGroup();

		junior = new Checkbox ( "Junior", category, false );
		senior = new Checkbox ( "Senior", category, false );
		iitans = new Checkbox ( "IITan", category, true );
		non_st = new Checkbox ( "Non-student", category, false );

		sex = new CheckboxGroup();

		male = new Checkbox ( "M", sex, false );
		female = new Checkbox ( "F", sex, true );

		dob_day = new Scrollbar ( Scrollbar.HORIZONTAL, 1, 1, 1, 32 );
		dob_month = new Scrollbar ( Scrollbar.HORIZONTAL, 1, 1, 1, 13 );
		dob_year = new Scrollbar ( Scrollbar.HORIZONTAL, 1980, 1, 1940, 1991 );

		dob_label = new Label ( "           Date of Birth     :      Day = " +
								dob_day.getValue() +
								" Month = " + dob_month.getValue() +
								" Year = " + dob_year.getValue() +
								"      ", Label.RIGHT );

		inst_List = new List ( 3, false );

		inst_List.addItem("(Not in List)");
		inst_List.select ( 0 );  // Above is default...

// Read the list of colleges from DBase...
//this try-catch block is important as forName and getConnection
//throw certain exceptions
	try
	{
	//first call initialiser functions	
	Class.forName (driver);

	//connect to the database
	conn = DriverManager.getConnection (connect_string);

	// Create a statement
	Statement stmt = conn.createStatement ();
	//jdbc initialisation done

	ResultSet rset = stmt.executeQuery ("select insti_name from institute where insti_name!='Default' and insti_name!='IITB'");

	while( rset.next() )
		inst_List.addItem(rset.getString(1));

	//get the next roll no from database
	Statement roll_stmt = conn.createStatement ();
	ResultSet r = roll_stmt.executeQuery ("select (max(roll_no) + 1) from examinee");
	r.next();
	RollNo=r.getInt(1);

	}
	catch(Exception e)
	{
		System.out.println(e.getMessage());
	}
		setLayout ( new FlowLayout() );
		resize ( 378, 400 );

		name.setEditable ( true );
		address.setEditable ( true );

		add ( new Label ( "Name : ", Label.RIGHT ) );
		add ( name );

		add ( new Label ( "Email : ", Label.CENTER ) );
		add ( address );

		add ( new Label ( "Sex : ", Label.RIGHT ) );
		add ( male );
		add ( female );

		add ( new Label ( "Category : ", Label.RIGHT ) );
		add ( junior );
		add ( senior );
		add ( iitans );
		add ( non_st );

		add ( new Label ( "Institute ( if applicable ): ", Label.RIGHT ) );
		add ( inst_List );
		add ( new Label ( "                         ", Label.RIGHT ) );

		add ( dob_label );
		add ( new Label ( "Day : " ) );
		add ( dob_day );
		add ( new Label ( "Month : " ) );
		add ( dob_month );
		add ( new Label ( "Year : " ) );
		add ( dob_year );

		add ( new Label ( "Your roll number: " ) );
		roll = new Label ( Integer.toString ( RollNo ) );
		add ( roll );

		accept = new Button ( "Accept & Register" );
		cancel = new Button ( "Cancel" );

		add ( accept );
		add ( cancel );

	}	// myDialog constructor

	public boolean handleEvent ( Event evtObj )
	{
		if ( evtObj.id == Event.WINDOW_DESTROY )
		{
			dispose();
			return true;
		}
		else if ( evtObj.target instanceof Scrollbar )
		{
			dob_label.setText ( "          Current Date of Birth     :      Day = " +
								dob_day.getValue() +
								" Month = " + dob_month.getValue() +
								" Year = " + dob_year.getValue() +
								"      ");
			repaint();
			return true;
		}
		return super.handleEvent ( evtObj );
	}

	//in this function we insert student record into database
	public boolean action ( Event evtObj, Object arg )
	{
		if ( evtObj.target instanceof Button )
		{
			if ( arg.equals ( "Accept & Register" ) )

			// Output info to DBase.

			{
				try
				{
				//first call initialiser functions	
				Class.forName (driver);

				//connect to the database
				conn = DriverManager.getConnection (connect_string);


				// Create a statement
				PreparedStatement insti_stmt = conn.prepareStatement ("Select insti_code from institute where insti_name=?");
				PreparedStatement insert_stmt = conn.prepareStatement (
"insert into examinee (roll_no,name,category_code,insti_code,sex,dob,email_id) values (?,?,?,?,?,?,?)");


				String categ = category.getCurrent().getLabel();
				String Sex = sex.getCurrent().getLabel();

				if ( categ == "IITan" )
				{
					institute = "IITB";
					categ="I";
				}
				else if ( categ == "Non-student" )
				{
					institute = "Default";
					categ="N";
				}
				else if(categ=="Junior")
				{
					categ="J";
					institute = inst_List.getSelectedItem();
				}
				else if(categ=="Senior")
				{
					categ="S";
					institute = inst_List.getSelectedItem();
				}

				if(institute=="(Not in List)")
					institute="Default";


				//to insert the record into database get insti_code
				insti_stmt.setString(1, institute);
				ResultSet i = insti_stmt.executeQuery ();

				i.next();
				int insti_code=i.getInt(1);

				dob = new java.sql.Date ( dob_year.getValue() - 1900,
				dob_month.getValue() - 1, dob_day.getValue() );

				insert_stmt.setInt(1, RollNo);
				insert_stmt.setString(2, name.getText());
				insert_stmt.setString(3, categ);
				insert_stmt.setInt(4, insti_code);
				insert_stmt.setString(5, Sex);
				insert_stmt.setDate(6, dob);
				insert_stmt.setString(7, address.getText());

				insert_stmt.executeUpdate();

			/*	String result = "Name : " + name.getText() +
				"\nSex : " + Sex +
				"\nD-O-B : " + dob.toString() +
				"\nAddress : " + address.getText() +
				"\nCategory : " + categ + "\nCollege : " +
				institute + "\n";

				System.out.print(result);*/

				}
				catch(Exception e)
				{
					// For now only...
					System.out.println(e.getMessage());
				}

			}

			dispose();
			return true;
		}
		return false;
	}
}	

class myDialogFrame extends Frame
{
	myDialog inputDialog;

	myDialogFrame ( String title ) { super ( title ); }

	public boolean handleEvent ( Event evtObj )
	{
		if ( evtObj.id == Event.WINDOW_DESTROY )
		{
			hide();
			return true;
		}
		return super.handleEvent ( evtObj );
	}

	public void show()
	{
		inputDialog = new myDialog ( this, "Register Online" );
		inputDialog.show();
	}
}
