import java.awt.*;
import java.applet.*;
import java.io.*;

/*
	<applet code="SetQPaper" width=130 height=200>
	 Please use a Java compatible browser like Netscape.
	</applet>
*/

public class SetQPaper extends Applet
{
	boolean worked = false;
	mainQPDialogFrame inputFrame;

	public void init()
	{
		add ( new Label ( "Question Paper Setting", Label.RIGHT ) );

		TextField login = new TextField ( "", 10 );
		login.setEditable ( true );
		TextField password = new TextField ( "", 10 );
		password.setEditable ( true );
		password.setEchoChar ( '!' );

		Button ok = new Button ( "OK" );

		add ( new Label ( "Access Name : ", Label.RIGHT ) );
		add ( login );
		add ( new Label ( "Password : ", Label.RIGHT ) );
		add ( password );

		add ( ok );
	}

	public void stop() { if ( worked ) inputFrame.setVisible ( false ); }

	public boolean action ( Event evtObj, Object arg )
	{
		if ( evtObj.target instanceof Button )
		{
			if ( arg.equals ( "OK" ) )
			{
				// Validate password. Here, I accept any rubbish...

				worked = true;

				inputFrame = new mainQPDialogFrame ( "MO Question Paper" );
				inputFrame.show();
				inputFrame.setSize ( 500, 350 );
				return true;
			}
		}
		return false;
	}
}

class mainQPDialogFrame extends Frame
{
	mainQPDialog mainInputDialog;

	mainQPDialogFrame ( String title ) { super ( title ); }

	public void show()
	{
		mainInputDialog = new mainQPDialog ( this, "MO Question Paper" );
		mainInputDialog.show();
	}

	public boolean handleEvent ( Event evtObj, Object arg )
	{
		if ( evtObj.id == Event.WINDOW_DESTROY )
		{
			setVisible ( false );
			return true;
		}
		return super.handleEvent ( evtObj );
	}
}

class mainQPDialog extends Dialog
{
	List q_category;
	Button done;
	Button quit;
	setQDialogFrame inputFrame;

	mainQPDialog ( Frame parent, String title )
	{
		super ( parent, title, true );

		setLayout ( new FlowLayout() );
		setSize ( 500, 200 );

		q_category = new List ( 3, true );

		// Add from DBase ...

		q_category.addItem ( "Graph Theory" );
		q_category.addItem ( "Number Theory" );
		q_category.addItem ( "Hindi" );

		done = new Button ( "Done" );
		quit = new Button ( "Quit" );

		add ( new Label ( "Select all categories of questions" ) );
		add ( q_category );
		add ( done );
		add ( quit );
	}

	public boolean handleEvent ( Event evtObj )
	{
		if ( evtObj.id == Event.WINDOW_DESTROY )
		{
			dispose();
			return true;
		}
		return super.handleEvent ( evtObj );
	}

	public boolean action ( Event evtObj, Object arg )
	{
		if ( evtObj.target instanceof Button )
		{
			if ( arg.equals ( "Done" ) && q_category.getSelectedItems().length > 0 )
			{
				inputFrame = new setQDialogFrame ( "Set Questions", q_category );
				inputFrame.show();
				inputFrame.setSize ( 500, 300 );
				return true;
			}
			if ( arg.equals ( "Quit" ) )
			{
				dispose();
				return true;
			}
		}
		return false;
	}
}

class setQDialogFrame extends Frame
{
	setQDialog inputDialog;
	List qCatList;

	setQDialogFrame ( String title, List q_category )
	{
		super ( title );
		qCatList = q_category;
	}

	public void show()
	{
		inputDialog = new setQDialog ( this, "Set questions", qCatList );
		inputDialog.show();
	}

	public boolean handleEvent ( Event evtObj, Object arg )
	{
		if ( evtObj.id == Event.WINDOW_DESTROY )
		{
			setVisible ( false );
			return true;
		}
		return super.handleEvent ( evtObj );
	}
}

class setQDialog extends Dialog
{
	String [] selectedCat;
	int counter = 0;

	Scrollbar numQ;
	CheckboxGroup level;
	Checkbox easy, medium, hard, hell;
	Button ok;

	TextArea question;
	Button accept, reject;

	String curr_category = "";
	Label cat_label;

	Button quit;

	setQDialog ( Frame parent, String title, List qCatList )
	{
		super ( parent, title, true );

		setLayout ( new FlowLayout() );
		setSize ( 500, 300 );

		selectedCat = qCatList.getSelectedItems();

		// Here, I assume that selectedCat has at least 1 ...
		// Add empty-list handling later...

		curr_category = selectedCat [ 0 ];
		numQ = new Scrollbar ( Scrollbar.HORIZONTAL, 0, 1, 0, 30 );
		level = new CheckboxGroup();
		easy = new Checkbox ( "Easy", level, false );
		medium = new Checkbox ( "Medium", level, true );
		hard = new Checkbox ( "Hard", level, false );
		hell = new Checkbox ( "Very Hard", level, false );
		ok = new Button ( "OK" );

		question = new TextArea ( "", 10, 30 );
		question.setEditable ( false );
		accept = new Button ( "Accept" );
		reject = new Button ( "Reject" );

		quit = new Button ( "Quit" );

		cat_label = new Label();
		cat_label.setText ( "Number of questions category " + curr_category +
		": " + numQ.getValue() );
		add ( cat_label );
		add ( numQ );
		add ( new Label ( "Select difficulty level: " ) );
		add ( easy );
		add ( medium );
		add ( hard );
		add ( hell );
		add ( ok );

		add ( question );
		add ( accept );
		add ( reject );

		add ( quit );
	}

	public boolean handleEvent ( Event evtObj )
	{
		if ( evtObj.id == Event.WINDOW_DESTROY )
		{
			dispose();
			return true;
		}
		if ( evtObj.target instanceof Scrollbar )
		{
			cat_label.setText ( "Number of questions category " +
			curr_category + ": " + numQ.getValue() );
			return true;
		}
		return super.handleEvent ( evtObj );
	}

	public boolean action ( Event evtObj, Object arg )
	{
		if ( evtObj.target instanceof Button )
		{
			if ( arg.equals ( "OK" ) )
			{
				// Query DBase for this type of question. Here, I just
				// dump it into the text area ...

				question.setText ( curr_category + "\n" +
				numQ.getValue() + "\n" +
				level.getCurrent().getLabel() + "\n" );
				
				return true;
			}
			if ( arg.equals ( "Accept" ) )
			{
				// The correct stuff goes in the DBase, this is rubbish ...

				System.out.println ( curr_category + "\n" +
				numQ.getValue() + "\n" +
				level.getCurrent().getLabel() + "\n" );

			// Satyam - remove these 2 lines, but don't change this part of
			// the code.

			// WARNING: Incorporate this code at the earliest...

			//	if ( ++this_categ_counter <= this_categ_number ) ...

				if ( ++counter < selectedCat.length )
					curr_category = selectedCat [ counter ];

				cat_label.setText ( "Number of questions category " +
				curr_category + ": " + numQ.getValue() );
				question.setText ( "" );

				return true;
			}
			if ( arg.equals ( "Reject" ) )
			{
				if ( ++counter < selectedCat.length )
					curr_category = selectedCat [ counter ];

				cat_label.setText ( "Number of questions category " +
				curr_category + ": " + numQ.getValue() );
				question.setText ( "" );
				return true;
			}
			if ( arg.equals ( "Quit" ) )
			{
				dispose();
				return true;
			}
		}
		return false;
	}
}
